"""comment

Revision ID: e42cfb727a76
Revises: aeb00fb9c3b4
Create Date: 2024-08-28 15:33:59.806288

"""

from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision: str = "e42cfb727a76"
down_revision: Union[str, None] = "aeb00fb9c3b4"
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    conn = op.get_bind()
    if conn.dialect.name == "mariadb":
        # ### commands auto generated by Alembic - please adjust! ###
        op.drop_constraint("tag_object_ibfk_2", "tag_object", type_="foreignkey")
        op.create_foreign_key("tag_object_ibfk_2", "tag_object", "object", ["object_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("tag_object_ibfk_1", "tag_object", type_="foreignkey")
        op.create_foreign_key("tag_object_ibfk_1", "tag_object", "tag", ["tag_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("tag_tag_ibfk_2", "tag_tag", type_="foreignkey")
        op.create_foreign_key("tag_tag_ibfk_2", "tag_tag", "tag", ["group_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("tag_tag_ibfk_1", "tag_tag", type_="foreignkey")
        op.create_foreign_key("tag_tag_ibfk_1", "tag_tag", "tag", ["member_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("tag_payload_ibfk_2", "tag_payload", type_="foreignkey")
        op.create_foreign_key("tag_payload_ibfk_2", "tag_payload", "payload", ["payload_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("tag_payload_ibfk_1", "tag_payload", type_="foreignkey")
        op.create_foreign_key("tag_payload_ibfk_1", "tag_payload", "tag", ["tag_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("closure_ibfk_2", "closure", type_="foreignkey")
        op.create_foreign_key("closure_ibfk_2", "closure", "object", ["descendant_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("closure_ibfk_1", "closure", type_="foreignkey")
        op.create_foreign_key("closure_ibfk_1", "closure", "object", ["ancestor_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("object_payload_ibfk_2", "object_payload", type_="foreignkey")
        op.create_foreign_key("object_payload_ibfk_2", "object_payload", "payload", ["payload_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("object_payload_ibfk_1", "object_payload", type_="foreignkey")
        op.create_foreign_key("object_payload_ibfk_1", "object_payload", "object", ["object_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("object_metadata_ibfk_2", "object_metadata", type_="foreignkey")
        op.create_foreign_key("object_metadata_ibfk_2", "object_metadata", "metadata", ["metadata_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("object_metadata_ibfk_1", "object_metadata", type_="foreignkey")
        op.create_foreign_key("object_metadata_ibfk_1", "object_metadata", "object", ["object_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("tag_metadata_ibfk_2", "tag_metadata", type_="foreignkey")
        op.create_foreign_key("tag_metadata_ibfk_2", "tag_metadata", "metadata", ["metadata_id"], ["id"], ondelete="CASCADE")
        op.drop_constraint("tag_metadata_ibfk_1", "tag_metadata", type_="foreignkey")
        op.create_foreign_key("tag_metadata_ibfk_1", "tag_metadata", "tag", ["tag_id"], ["id"], ondelete="CASCADE")
    else:
        print("SQLite detected, skipping foreign key constraints with ON DELETE CASCADE")
    # ### end Alembic commands ###


def downgrade() -> None:
    pass
    # ### commands auto generated by Alembic - please adjust! ###
    # ### end Alembic commands ###
